package test.laliluna.tutorial.junitejb;

import java.rmi.RemoteException;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;

import junit.framework.TestCase;
import de.laliluna.tutorial.library.entity.interfaces.BookValue;
import de.laliluna.tutorial.library.session.interfaces.BookSession;
import de.laliluna.tutorial.library.session.interfaces.BookSessionHome;

/**
 * @author http://www.laliluna.de
 */
public class BookSessionTest extends TestCase {

    protected BookSessionHome bookSessionHome;
    protected BookSession bookSession;
    private BookValue bookValue;
    
    public void setUp() throws Exception {
        super.setUp();
       
        Context context = new InitialContext();
        Object finderRef = context.lookup(BookSessionHome.JNDI_NAME);
        bookSessionHome = (BookSessionHome) PortableRemoteObject
                .narrow(finderRef, BookSessionHome.class);
        bookSession = bookSessionHome.create();
        
        
        // set a example book to add
        bookValue = new BookValue();
        bookValue.setAuthor("laliluna");
        bookValue.setTitle("JunitEE EJB Example");
        bookValue.setAvailable(new Boolean(true));
    }
    
    public void tearDown() throws Exception {
        super.tearDown();
        bookSession = null;
        bookSessionHome = null;
        bookValue = null;
    }
    
    public void testSaveBook() {
    	try{
    	    bookSession.saveBook(this.bookValue);
    	} catch(Exception e){
    	    fail("Received Exception: "
    	         + e.getClass()
                 + " : " + e.getMessage());
    	}  
    }
    
    public void testGetAllBooks() {
        try {
            assertNotNull(bookSession.getAllBooks());
        } catch (Exception e) {
            fail("Received Exception: " 
                 + e.getClass() 
                 + " : " + e.getMessage());
        }
        
    }

}